﻿using MaterialSkin.Controls;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using WaAutoReplyBot;
using WASender;

namespace WaDefender
{
    public partial class Activate : MyMaterialPopOp
    {

        
        WaDefenderForm mainForm;
        MaterialSkin.MaterialSkinManager materialSkinManager;

        public Activate(WaDefenderForm _mainForm)
        {
            this.mainForm = _mainForm;
            InitializeComponent();
            materialSkinManager = _mainForm.materialSkinManager;
        }

        private void Activate_Load(object sender, EventArgs e)
        {
            init();
        }

        private void init()
        {
            this.Text = Strings.ActivateAppName + " " + Strings.AppName + "(" + Strings.SoftwareVersion + ")";
            lblActivationCode.Text = Strings.YourActivationCodeis;
            label1.Text = Strings.ProvideYourActivationKeyHere;
            btnActivate.Text = Strings.ActivateNow;
            txtActivationCode.Text =  "WD-"+Security.FingerPrint.Value();
            materialButton1.Text = Strings.Exit;
        }

        private void materialButton1_Click(object sender, EventArgs e)
        {
            Environment.Exit(1);
        }

        private void btnActivate_Click(object sender, EventArgs e)
        {
            try
            {
                string jsonstring = Config.Base64Decode(txtKey.Text);
                Models.ActivationModel obj = Newtonsoft.Json.JsonConvert.DeserializeObject<Models.ActivationModel>(jsonstring);

                if (txtActivationCode.Text == Config.Base64Decode(obj.ActivationCode))
                {
                    if (obj.EndDate < DateTime.Now)
                    {
                        MaterialSnackBar SnackBarMessage = new MaterialSnackBar(Strings.InvalidActivationKey, Strings.OK, true);
                        SnackBarMessage.Show(this);
                    }
                    else
                    {
                        MaterialSnackBar SnackBarMessage = new MaterialSnackBar(Strings.ActivationSuccessfull, Strings.OK, true);
                        SnackBarMessage.Show(this);
                        var NewjsonString = Newtonsoft.Json.JsonConvert.SerializeObject(obj);
                        Config.ActivateProduct(Config.Base64Encode(NewjsonString));
                        this.Hide();
                        // waSenderForm.Show();
                        
                    }

                }
                else
                {
                    MaterialSnackBar SnackBarMessage = new MaterialSnackBar(Strings.InvalidActivationKey, Strings.OK, true);
                    SnackBarMessage.Show(this);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error", ex.Message);
            }

        }



        private void Activate_FormClosed(object sender, FormClosedEventArgs e)
        {
            Environment.Exit(1);
        }
    }
}
