﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using WaAutoReplyBot;
using WaDefender.Models;

namespace WaDefender
{
    public partial class Result : MyMaterialPopOp
    {
        DefenderTransactionModel defenderTransactionModed;
        public Result(DefenderTransactionModel _defenderTransactionModed)
        {
            InitializeComponent();
            defenderTransactionModed = _defenderTransactionModed;
        }

        private void Result_Load(object sender, EventArgs e)
        {
            initLanguages();
            materialLabel2.Text= Convert.ToInt32(defenderTransactionModed.percentage).ToString() + "%";
            materialLabel4.Text = Utils.returnLevelString(defenderTransactionModed.strongnessLevel); //defenderTransactionModed.strongnessLevel.ToString();

            materialCheckbox1.Checked = true;
            materialCheckbox2.Checked = true;

        }

        private void initLanguages()
        {
            this.Text = Strings.Summery;
            materialLabel1.Text = Strings.OverallAccountStrongness;
            materialLabel3.Text = Strings.OverallAccountStatus;
            groupBox1.Text = Strings.Export;
            materialCheckbox1.Text = Strings.IncludeSuggessions;
            materialCheckbox2.Text = Strings.IncludeDetails;
            materialButton1.Text = Strings.Exportfullreport;
        }

        private void materialButton1_Click(object sender, EventArgs e)
        {
            string strim = "";


            string topStrins = File.ReadAllText("helpdocs\\report-part-1.html");
            string BottomStrins = File.ReadAllText("helpdocs\\report-part-2.html");

            bool includeSuggessions = materialCheckbox1.Checked;
            bool includeDetais = materialCheckbox2.Checked; ;

            topStrins = topStrins.Replace("Module", Strings.Module);
            topStrins = topStrins.Replace("Result", Strings.Result);
            topStrins = topStrins.Replace("Strongness Percentage", Strings.StrongnessPercentage);
            topStrins = topStrins.Replace("Strongness Level", Strings.StrongnessLevel);
            topStrins = topStrins.Replace("Details", Strings.Details);
            topStrins = topStrins.Replace("Suggessions", Strings.Suggessions);
            #region 
            strim += "";
            strim += "<tr>";

            strim += "<td>"+ Strings.TotalUnSavedChats +"\r\n</td>";

            strim += "<td>";
            strim += defenderTransactionModed.totalNumberOfChatsModel.totalChats;
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.totalNumberOfChatsModel.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.totalNumberOfChatsModel.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            strim += "-";
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.totalNumberOfChatsModel.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.totalNumberOfChatsModel.suggessions);
                }
            }
            strim += "</td>";

            strim += "</tr>";
            #endregion

            #region 
            strim += "";
            strim += "<tr>";

            strim += "<td>"+ Strings.NotInterestedChats +"\r\n</td>";

            strim += "<td>";
            strim +=  defenderTransactionModed.noInterestedModel.NumberOfotInteestedChats.Count();
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.noInterestedModel.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.noInterestedModel.strongnessLevel);
            strim += "</td>";


            
            strim += "<td>";
            if (includeDetais)
            {
                strim += Strings.Listofnotinterestednumbers + " <br/> ";
                strim += "<ul>";
                foreach (var item in defenderTransactionModed.noInterestedModel.NumberOfotInteestedChats)
                {
                    strim += "<li>" + item.fromNumber + "</li>";
                }
                strim += "</ul>";
            }
            
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.noInterestedModel.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.noInterestedModel.suggessions);
                }
            }
            
            
            strim += "</td>";

            strim += "</tr>";
            #endregion

            #region
            strim += "";
            strim += "<tr>";

            strim += "<td>"+ Strings.TotalUnSavedChats +"\r\n</td>";

            strim += "<td>";
            strim += defenderTransactionModed.unsavedchats.totalChats;
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.unsavedchats.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.unsavedchats.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            strim += "-";
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.unsavedchats.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.unsavedchats.suggessions);
                }
            }
            

            strim += "</td>";

            strim += "</tr>";
            #endregion


            #region
            strim += "";
            strim += "<tr>";

            strim += "<td>"+Strings.TotalChatWithContacts+"\r\n</td>";

            strim += "<td>";
            strim += defenderTransactionModed.savedchats.totalChats;
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.savedchats.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.savedchats.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            strim += "-";
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.savedchats.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.savedchats.suggessions);
                }
            }
            

            strim += "</td>";

            strim += "</tr>";
            #endregion



            #region
            strim += "";
            strim += "<tr>";

            strim += "<td>"+Strings.ContactListCount+"\r\n</td>";

            strim += "<td>";
            strim += defenderTransactionModed.contactList.totalChats;
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.contactList.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.contactList.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            strim += "-";
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.contactList.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.contactList.suggessions);
                }
            }
            
            strim += "</td>";

            strim += "</tr>";
            #endregion


            #region
            strim += "";
            strim += "<tr>";

            strim += "<td>"+ Strings.AccountOldness +"\r\n</td>";

            strim += "<td>";
            strim += defenderTransactionModed.firstChatMessageModel.days + " (Days old)";
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.firstChatMessageModel.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.firstChatMessageModel.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            if (includeDetais)
            {
                strim += Strings.Wefoundfirstmessageofthisnumber +  " " + defenderTransactionModed.firstChatMessageModel.number;
            }
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.firstChatMessageModel.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.firstChatMessageModel.suggessions);
                }
            }
            

            strim += "</td>";

            strim += "</tr>";
            #endregion


            #region
            strim += "";
            strim += "<tr>";

            strim += "<td>"+ Strings.TotalNumberofGroups +"\r\n</td>";

            strim += "<td>";
            strim += defenderTransactionModed.totalGroups.totalChats;
            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.totalGroups.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.totalGroups.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            strim += "-";
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.totalGroups.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.totalGroups.suggessions);
                }
            }
            

            strim += "</td>";

            strim += "</tr>";
            #endregion


            #region
            strim += "";
            strim += "<tr>";

            strim += "<td>" +Strings.GroupActivity+ "  \r\n</td>";

            strim += "<td>";
            strim += "Send Group Message By you -" + defenderTransactionModed.groupActivityModel.myMessageCount + "<br>";
            strim += "Send Group Message from others -" + defenderTransactionModed.groupActivityModel.othermessageCount + "<br>";

            strim += "</td>";

            strim += "<td>";
            strim += defenderTransactionModed.groupActivityModel.percentage.ToString() + "%";
            strim += "</td>";

            strim += "<td>";
            strim += Utils.returnLevelString(defenderTransactionModed.groupActivityModel.strongnessLevel);
            strim += "</td>";

            strim += "<td>";
            strim += "-";
            strim += "</td>";

            strim += "<td>";
            if (includeSuggessions)
            {
                if (defenderTransactionModed.groupActivityModel.percentage < 100)
                {
                    strim += AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.groupActivityModel.suggessions);
                }
            }
            

            strim += "</td>";

            strim += "</tr>";
            #endregion


            string fullreportHtml = topStrins + strim + BottomStrins;
            String FolderPath = Config.GetTempFolderPath();

            String file = Path.Combine(FolderPath, "Report" + Guid.NewGuid().ToString() + ".html");

            string NewFileName = file.ToString();

            using (FileStream fs = new FileStream(NewFileName, FileMode.Create))
            {
                using (StreamWriter w = new StreamWriter(fs, Encoding.UTF8))
                {
                    w.WriteLine(fullreportHtml);
                }
            }

            savesampleExceldialog.FileName = "EnterYourAccountName.html";
            if (savesampleExceldialog.ShowDialog() == DialogResult.OK)
            {
                File.Copy(NewFileName, savesampleExceldialog.FileName.EndsWith(".html") ? savesampleExceldialog.FileName : savesampleExceldialog.FileName + ".xlsx", true);
                //Utils.showAlert(Strings.Filedownloadedsuccessfully, Alerts.Alert.enmType.Success);
            }

        }
    }
}
