﻿using MaterialSkin;
using MaterialSkin.Controls;
//using Microsoft.Web.WebView2.WinForms;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using WaDefender.Models;
using WASender.enums;
using WASender.Models;

namespace WaDefender
{
    public static class Utils
    {


        public static WaBrowser _waBrowser { get; set; }

        public static WaBrowser waBrowser
        {
            get
            {
                return _waBrowser;
            }
            set { _waBrowser = value; }
        }


 

  
  

        public static MaterialSkin.MaterialSkinManager SetColorScheme(MaterialSkin.MaterialSkinManager materialSkinManager, MaterialForm materialForm, Model.ColorSchemeenum? colorSchemeenum = null)
        {
            materialSkinManager = MaterialSkin.MaterialSkinManager.Instance;
            materialSkinManager.AddFormToManage(materialForm);
            materialSkinManager.Theme = MaterialSkin.MaterialSkinManager.Themes.LIGHT;
            if (colorSchemeenum == null)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Green700, Primary.Green400, Primary.Green900, Accent.Green700, TextShade.WHITE);
                //return;
            }
            if (colorSchemeenum == Model.ColorSchemeenum.Green)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Green700, Primary.Green400, Primary.Green900, Accent.Green700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Red)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Red700, Primary.Red400, Primary.Red900, Accent.Red700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Amber)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Amber700, Primary.Amber400, Primary.Amber900, Accent.Amber700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Blue)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Blue700, Primary.Blue400, Primary.Blue900, Accent.Blue700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.BlueGrey)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.BlueGrey700, Primary.BlueGrey400, Primary.BlueGrey900, Accent.Blue700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Brown)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Brown700, Primary.Brown400, Primary.Brown900, Accent.Blue700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Cyan)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Cyan700, Primary.Cyan400, Primary.Cyan900, Accent.Cyan700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.DeepOrange)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.DeepOrange700, Primary.DeepOrange400, Primary.DeepOrange900, Accent.DeepOrange700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.DeepPurple)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.DeepPurple700, Primary.DeepPurple400, Primary.DeepPurple900, Accent.DeepPurple700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Grey)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Grey700, Primary.Grey400, Primary.Grey900, Accent.Blue700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Indigo)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Indigo700, Primary.Indigo400, Primary.Indigo900, Accent.Indigo700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.LightBlue)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.LightBlue700, Primary.LightBlue400, Primary.LightBlue900, Accent.LightBlue700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Lime)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Lime700, Primary.Lime400, Primary.Lime900, Accent.Lime700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Orange)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Orange700, Primary.Orange400, Primary.Orange900, Accent.Orange700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Pink)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Pink700, Primary.Pink400, Primary.Pink900, Accent.Pink700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Purple)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Purple700, Primary.Purple400, Primary.Purple900, Accent.Purple700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Teal)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Teal700, Primary.Teal400, Primary.Teal900, Accent.Teal700, TextShade.WHITE);
            }
            else if (colorSchemeenum == Model.ColorSchemeenum.Yellow)
            {
                materialSkinManager.ColorScheme = new ColorScheme(Primary.Yellow700, Primary.Yellow400, Primary.Yellow900, Accent.Yellow700, TextShade.WHITE);
            }
            return materialSkinManager;

        }

        public static string returnLevelString(StrongnessLevel strongnessLevel)
        {
            if (strongnessLevel == StrongnessLevel.Best)
            {
                return Strings.Best;
            }
            else if (strongnessLevel == StrongnessLevel.Better)
            {
                return Strings.Better;
            }
            else if (strongnessLevel == StrongnessLevel.DontKnow)
            {
                return Strings.DontKnow;
            }
            else if (strongnessLevel == StrongnessLevel.Good)
            {
                return Strings.Good;
            }
            else if (strongnessLevel == StrongnessLevel.Poor)
            {
                return Strings.Poor;
            }
            else if (strongnessLevel == StrongnessLevel.Weak)
            {
                return Strings.Weak;
            }
            else
            {
                return Strings.DontKnow;
            }
        }

      

        public static void ChangeCampStatus(CampaignStatusEnum _campaignStatus, Label lblRunStatus)
        {
            if (_campaignStatus == CampaignStatusEnum.NotStarted)
            {
                lblRunStatus.ForeColor = Color.Orange;
                lblRunStatus.Text = Strings.NotStarted;
            }
            else if (_campaignStatus == CampaignStatusEnum.Running)
            {
                lblRunStatus.ForeColor = Color.Green;
                lblRunStatus.Text = Strings.Running;
            }
            else if (_campaignStatus == CampaignStatusEnum.Paused)
            {
                lblRunStatus.ForeColor = Color.Blue;
                lblRunStatus.Text = Strings.Paused;
            }
            else if (_campaignStatus == CampaignStatusEnum.Stopped)
            {
                lblRunStatus.ForeColor = Color.Red;
                lblRunStatus.Text = Strings.Stopped;
            }
            else if (_campaignStatus == CampaignStatusEnum.Error)
            {
                lblRunStatus.ForeColor = Color.DarkRed;
                lblRunStatus.Text = Strings.Error;
            }

            else if (_campaignStatus == CampaignStatusEnum.Finish)
            {
                lblRunStatus.ForeColor = Color.DarkGray;
                lblRunStatus.Text = Strings.Completed;
            }
        }

        public static void ChangeInitStatus(InitStatusEnum _initStatus, Label lblInitStatus)
        {
            if (_initStatus == InitStatusEnum.NotInitialised)
            {
                lblInitStatus.ForeColor = Color.Orange;
                lblInitStatus.Text = Strings.NotInitialised;
            }
            else if (_initStatus == InitStatusEnum.Initialising)
            {
                lblInitStatus.ForeColor = Color.Gray;
                lblInitStatus.Text = Strings.Initialising;
            }
            else if (_initStatus == InitStatusEnum.Initialised)
            {
                lblInitStatus.ForeColor = Color.Green;
                lblInitStatus.Text = Strings.Initialised;
            }
            else if (_initStatus == InitStatusEnum.Unable)
            {
                lblInitStatus.ForeColor = Color.DarkRed;
                lblInitStatus.Text = Strings.Error;
            }
            else if (_initStatus == InitStatusEnum.Stopped)
            {
                lblInitStatus.ForeColor = Color.Red;
                lblInitStatus.Text = Strings.Stopped;
            }


        }




    }
}
