﻿
using MaterialSkin;
using MaterialSkin.Controls;
using mshtml;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using ProjectCommon.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using WaDefender.Models;
using WaHammer;
using WASender.enums;
using WASender.Models;

namespace WaDefender
{
    public partial class WaDefenderForm : MaterialForm
    {
        public MaterialSkin.MaterialSkinManager materialSkinManager;
        InitStatusEnum initStatusEnum;
        CampaignStatusEnum campaignStatusEnum;
        System.Windows.Forms.Timer timerInitChecker;
        DefenderTransactionModel defenderTransactionModed;
        GeneralSettingsModel generalSettingsModel;
        public WaDefenderForm()
        {
            InitializeComponent();
            //webBrowser1.mess
        }



        private void Form1_Load(object sender, EventArgs e)
        {
            initLanguages();
            this.Text = Strings.AppName;
            materialSkinManager = Utils.SetColorScheme(materialSkinManager, this, Model.ColorSchemeenum.Purple);
            CHeckForActivation();
            label1.BackColor = System.Drawing.Color.Transparent;
            label1.ForeColor = System.Drawing.Color.White;
            ChangeInitStatus(InitStatusEnum.NotInitialised);
            ChangeCampStatus(CampaignStatusEnum.NotStarted);
            webBrowser1.ScriptErrorsSuppressed = true;

            LoadDocument();
        }

        private void CHeckForActivation()
        {
            if (!Config.IsProductActive())
            {
                Activate activate = new Activate(this);
                this.Hide();
                activate.ShowDialog();
            }
        }

        private void LoadDocument()
        {
            webBrowser1.Visible = false;
            pictureBox1.Visible = true;
            string curDir = Directory.GetCurrentDirectory();
            var uri = new Uri(String.Format("file:///{0}/helpdocs/Dashboard.html", curDir));
            webBrowser1.DocumentCompleted += webBrowser1_DocumentCompleted;
            webBrowser1.Url = uri;

            
            
        }


        private void addNewCss(string CSS)
        {
            System.Windows.Forms.HtmlElement head = webBrowser1.Document.GetElementsByTagName("head")[0];
            System.Windows.Forms.HtmlElement styleEl = webBrowser1.Document.CreateElement("style");
            styleEl.InnerHtml = CSS;
            head.AppendChild(styleEl);
        }

        private void setPrimaryColor(int R, int G, int B)
        {
            addNewCss(@" .btn-primary {background-color:rgb(" + R + ", " + G + ", " + B + "); };");
            addNewCss(@" .btn-primary.active, .btn-primary:active, .btn-primary:focus, .btn-primary:hover{background-color:rgb(" + R + ", " + G + ", " + B + ")!important}; ");
            addNewCss(@" .btn-primary.disabled, .btn-primary:disabled {background-color:rgb(" + R + ", " + G + ", " + B + "); };");
            addNewCss(@" .badge-primary {background-color:rgb(" + R + ", " + G + ", " + B + "); };");
        }
        private async void webBrowser1_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            setPrimaryColor(materialSkinManager.ColorScheme.PrimaryColor.R, materialSkinManager.ColorScheme.PrimaryColor.G, materialSkinManager.ColorScheme.PrimaryColor.B);

            setBrowserLanguage();

            await Task.Delay(1000);
            webBrowser1.Visible = true;
            pictureBox1.Visible = false;
        }

        private void setBrowserLanguage()
        {
            
            webBrowser1.Document.InvokeScript("changeClasstext", new string[] { "Strongness", Strings.Strongness });
            webBrowser1.Document.InvokeScript("changeClasstext", new string[] { "btnSuggessions", Strings.Suggessions });
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlTotalNumberofChats", Strings.TotalNumberofChats });
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlNotInterestedChats", Strings.NotInterestedChats});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlTotalUnSavedChats", Strings.TotalUnSavedChats});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlTotalChatWithContacts", Strings.TotalChatWithContacts});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlContactListCount", Strings.ContactListCount});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlAccountOldness", Strings.AccountOldness});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlTotalNumberofGroups", Strings.TotalNumberofGroups});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "ttlGroupActivity", Strings.GroupActivity});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "exampleModalLongTitle", Strings.suggestions});
            webBrowser1.Document.InvokeScript("changeIdtext", new string[] { "btnClose", Strings.Close });

            webBrowser1.Document.InvokeScript("changeModelDescription", new string[] { "NotInterestedChatsDesc", Strings.NotInterestedChatsDesc });
            webBrowser1.Document.InvokeScript("changeModelDescription", new string[] { "TotalUnSavedChatsDesc", Strings.TotalUnSavedChatsDesc });
            webBrowser1.Document.InvokeScript("changeModelDescription", new string[] { "TotalChatWithContactsDesc", Strings.TotalChatWithContactsDesc });
            webBrowser1.Document.InvokeScript("changeModelDescription", new string[] { "ContactListCountDesc", Strings.ContactListCountDesc });
            webBrowser1.Document.InvokeScript("changeModelDescription", new string[] { "AccountOldnessDesc", Strings.AccountOldnessDesc });
            webBrowser1.Document.InvokeScript("changeModelDescription", new string[] { "GroupActivityDesc", Strings.GroupActivityDesc });
        }


        private void ChangeInitStatus(InitStatusEnum _initStatus)
        {
            this.initStatusEnum = _initStatus;
            Utils.ChangeInitStatus(_initStatus, lblInitStatus);
        }

        private void ChangeCampStatus(CampaignStatusEnum _campaignStatus)
        {
            this.campaignStatusEnum = _campaignStatus;
            Utils.ChangeCampStatus(_campaignStatus, lblRunStatus);
        }

        private void initLanguages()
        {
            getSelectedLanguage();
            SetLanguagesDropdown();


            comboBox1.SelectedText = generalSettingsModel.selectedLanguage;


            this.Text = Strings.AppName;
            label1.Text = Strings.SoftwareVersion;
            materialLabel2.Text = Strings.InitiateWhatsAppScaneQRCodefromyourmobile;
            btnInitWA.Text = Strings.ClicktoInitiate;
            label5.Text = Strings.Status;
            label3.Text = Strings.Status;
            materialButton1.Text = Strings.ScanNow;
            //label2.Text = Strings.Parameter;
        }

        private void SetLanguagesDropdown()
        {
            DirectoryInfo d = new DirectoryInfo("languages");
            FileInfo[] Files = d.GetFiles("*.json"); //Getting Text files
            string str = "";

            comboBox1.DisplayMember = "Text";
            comboBox1.ValueMember = "Value";
            foreach (FileInfo file in Files)
            {
                // str = str + ", " + file.Name;

                try
                {
                    comboBox1.Items.Add(new { Text = file.Name.Split('.')[0], Value = file.Name });
                }
                catch (Exception ex)
                {

                }
            }
        }

        private void getSelectedLanguage()
        {
            string settingPath = Config.GetGeneralSettingsFilePath();

            if (!File.Exists(settingPath))
            {
                File.Create(settingPath).Close();
            }
            generalSettingsModel = new GeneralSettingsModel();
            generalSettingsModel.selectedLanguage = Strings.DefaultLanguage;
            try
            {
                string GeneralSettingJson = "";
                using (StreamReader r = new StreamReader(settingPath))
                {
                    GeneralSettingJson = r.ReadToEnd();
                }
                var dict = JsonConvert.DeserializeObject<GeneralSettingsModel>(GeneralSettingJson);
                if (dict != null)
                {
                    generalSettingsModel = dict;
                }
                if (generalSettingsModel.selectedLanguage == null || generalSettingsModel.selectedLanguage == "")
                {
                    generalSettingsModel.selectedLanguage = Strings.DefaultLanguage;
                }
                Strings.selectedLanguage = generalSettingsModel.selectedLanguage;
            }
            catch (Exception ex)
            {

            }

        }
        private void startProgressBar()
        {
            progressBar1.Show();
            progressBar1.Style = ProgressBarStyle.Marquee;
            progressBar1.MarqueeAnimationSpeed = 30;
        }
        private void stopProgressbar()
        {
            progressBar1.Hide();
            progressBar1.Style = ProgressBarStyle.Blocks;
            progressBar1.MarqueeAnimationSpeed = 0;
        }

      
        private async void materialButton1_Click(object sender, EventArgs e)
        {
            if (campaignStatusEnum == CampaignStatusEnum.Finish)
            {
                LoadDocument();
            }

            if (campaignStatusEnum == CampaignStatusEnum.Paused)
            {

                ChangeCampStatus(CampaignStatusEnum.Running);
                startProgressBar();

            }
            else if (initStatusEnum == InitStatusEnum.Initialised)
            {
                defenderTransactionModed = new DefenderTransactionModel();
                LoadDocument();
                string result = await RunTheTask();
            }
            else
            {

            }
        }

        private async Task<string> RunTheTask()
        {
            await Task.Delay(2000);
            ChangeCampStatus(CampaignStatusEnum.Running);
            startProgressBar();
            string result = await initJA();
            await Task.Delay(2000);

            increase_progress_totalchats("totalNumberChatProgress");
            await Task.Delay(1000);
            string resultC = await do_totalchats();
            await Task.Delay(2000);

            increase_progress_totalchats("totalNotInterestedProgress");
            await Task.Delay(1000);
            string result2 = await do_notInterested();
            await Task.Delay(2000);


            increase_progress_totalchats("UnSavedProgress");
            await Task.Delay(1000);
            string resultU = await do_totalUnSavedCHats();
            await Task.Delay(2000);

            increase_progress_totalchats("SavedProgress");
            await Task.Delay(1000);
            string resultS = await do_totalSavedCHats();
            await Task.Delay(2000);

            increase_progress_totalchats("ContactProgress");
            await Task.Delay(1000);
            string resultCL = await do_ContactList();
            await Task.Delay(2000);

            increase_progress_totalchats("OldnessProgress");
            await Task.Delay(1000);
            string resultO = await do_checkoldness();
            await Task.Delay(2000);

            increase_progress_totalchats("totalNumberGroupProgress");
            await Task.Delay(1000);
            string resultG = await do_totalGroups();
            await Task.Delay(2000);

            increase_progress_totalchats("GrouActivityProgress");
            await Task.Delay(1000);
            string resultGA = await do_CheckGroupActivities();
            await Task.Delay(2000);
            ChangeCampStatus(CampaignStatusEnum.Finish);
            stopProgressbar();

            #region OverAllPercentage

            double TotalPercentageValue = 
                  defenderTransactionModed.totalNumberOfChatsModel.percentage
                + defenderTransactionModed.totalGroups.percentage
                + defenderTransactionModed.unsavedchats.percentage
                + defenderTransactionModed.savedchats.percentage
                + defenderTransactionModed.noInterestedModel.percentage
                + defenderTransactionModed.contactList.percentage
                + defenderTransactionModed.firstChatMessageModel.percentage
                + defenderTransactionModed.groupActivityModel.percentage;


            defenderTransactionModed.percentage = TotalPercentageValue / 800 * 100;
            defenderTransactionModed.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.percentage);

            #endregion  

            Result form = new Result(defenderTransactionModed);
            form.ShowDialog();

            return "";
        }

        

        private void increase_progress_totalchats(string elementId)
        {
            webBrowser1.Document.InvokeScript("setProgressId", new string[] { elementId, "10" });
        }

        private async Task<string> do_CheckGroupActivities()
        {
            try
            {
                string result = await WPPHelper.getGroupActivities(Utils.waBrowser.webView21);
                defenderTransactionModed.groupActivityModel = new GroupActivityModel();
                defenderTransactionModed.groupActivityModel.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.GroupActivity);
                if (result != "")
                {
                    var results = JsonConvert.DeserializeObject<List<GroupActivityModel>>(result);
                    defenderTransactionModed.groupActivityModel = results[0];
                    setGroupActivities();

                }
            }
            catch (Exception ex)
            {

            }

            return "";
        }

        private async Task<string> do_checkoldness()
        {
            try
            {
                string result = await WPPHelper.CheckAccountOldness(Utils.waBrowser.webView21);
                defenderTransactionModed.firstChatMessageModel = new ProjectCommon.Models.FirstChatMessageModel();
                
                defenderTransactionModed.firstChatMessageModel.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.AccountOldness);
                if (result != "")
                {
                    var results = JsonConvert.DeserializeObject<List<FirstChatMessageModel>>(result);
                    if (results.Count() > 0)
                    {
                        defenderTransactionModed.firstChatMessageModel = results[0];
                    }
                    setOldness();
                }

            }
            catch (Exception ex)
            {

            }
            return "";
        }

        private async Task<string> do_ContactList()
        {
            List<WAPI_ContactModel> totalchats = await WPPHelper.getMyContacts(Utils.waBrowser.webView21);
            if (totalchats == null)
            {
                Thread.Sleep(1000);
                totalchats = await WPPHelper.getMyContacts(Utils.waBrowser.webView21); ;
            }
            SetContatList(totalchats.Count().ToString());
            return "";
        }


        private async Task<string> do_totalSavedCHats()
        {
            string totalchats = await WPPHelper.getTotalSavedChats(Utils.waBrowser.webView21);
            if (totalchats == null)
            {
                Thread.Sleep(1000);
                totalchats = await WPPHelper.getTotalSavedChats(Utils.waBrowser.webView21); ;
            }
            SetSavedChats(totalchats);
            return "";
        }
        private async Task<string> do_totalUnSavedCHats()
        {
            string totalchats = await WPPHelper.getTotalUnSavedChats(Utils.waBrowser.webView21);
            if (totalchats == null)
            {
                Thread.Sleep(1000);
                totalchats = await WPPHelper.getTotalUnSavedChats(Utils.waBrowser.webView21); ;
            }
            SetUnSavedChats(totalchats);
            return "";
        }


        private async Task<string> do_totalchats()
        {
            string NumberOfCHats = await getTotalNumberOfCats();
            if (NumberOfCHats == null)
            {
                Thread.Sleep(1000);
                NumberOfCHats = await getTotalNumberOfCats();
            }
            SetTotalNumberOfCHats(NumberOfCHats);
            return "";
        }

        private async Task<string> do_totalGroups()
        {
            string totalGroups = await getTotalNumberOfGroups();
            if (totalGroups == null)
            {
                Thread.Sleep(1000);
                totalGroups = await getTotalNumberOfGroups();
            }
            SetTotalNumberOfGroups(totalGroups);
            return "";
        }

        private async Task<string> do_notInterested()
        {
            try
            {
                string ss = await WPPHelper.readAllchatsfor_fromto(Utils.waBrowser.webView21);
                string Totalchats = await WPPHelper.check_totalUnSavedChats(Utils.waBrowser.webView21);
                int fromto = 0;
                if (Totalchats != "" && Totalchats != null)
                {
                    int _Totalchats = Convert.ToInt32(Totalchats);
                    int totalProgress = 10;
                    while (fromto < _Totalchats)
                    {
                        Thread.Sleep(300);
                        totalProgress = totalProgress + 10;
                        string _fromtp = await WPPHelper.check_fromto(Utils.waBrowser.webView21);
                        if (_fromtp != "" && _fromtp != null)
                        {
                            fromto = Convert.ToInt32(_fromtp);
                        }
                    }
                    string fromtoString = await WPPHelper.getFromto_fromto(Utils.waBrowser.webView21);

                    defenderTransactionModed.noInterestedModel = new NoInterestedModel();
                    defenderTransactionModed.noInterestedModel.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.NotInterestedChats);
                    defenderTransactionModed.noInterestedModel.fromToModelList = JsonConvert.DeserializeObject<List<FromToModel>>(fromtoString);
                    defenderTransactionModed.noInterestedModel.NumberOfotInteestedChats = defenderTransactionModed.noInterestedModel.fromToModelList.Where(x => x.fromMe > 0 && x.tome == 0).ToList();
                    SetTotalNOtInteresteds();
                }
            }
            catch (Exception ex)
            {


            }
            return "";
        }

        private void setGroupActivities()
        {
            defenderTransactionModed.groupActivityModel.percentage = AlgorithmCalculator.CalculateTotalGroupActivityPercentage(defenderTransactionModed.groupActivityModel.grpupActiviPercentage);
            defenderTransactionModed.groupActivityModel.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.groupActivityModel.percentage);
            webBrowser1.Document.InvokeScript("setGroupActivities", new string[] { defenderTransactionModed.groupActivityModel.myMessageCount.ToString() + "/" + defenderTransactionModed.groupActivityModel.othermessageCount, defenderTransactionModed.groupActivityModel.percentage.ToString(), defenderTransactionModed.groupActivityModel.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.groupActivityModel.strongnessLevel) });


            defenderTransactionModed.groupActivityModel.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.GroupActivity);
            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.groupActivityModel.suggessions);
            this.webBrowser1.Document.GetElementById("sug_GA").InnerHtml = content;
        }

        private void setOldness()
        {
            defenderTransactionModed.firstChatMessageModel.percentage = AlgorithmCalculator.CalculateOldness(defenderTransactionModed.firstChatMessageModel.days);
            defenderTransactionModed.firstChatMessageModel.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.firstChatMessageModel.percentage);
            webBrowser1.Document.InvokeScript("setOldness", new string[] { defenderTransactionModed.firstChatMessageModel.days.ToString(), defenderTransactionModed.firstChatMessageModel.percentage.ToString(), defenderTransactionModed.firstChatMessageModel.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.firstChatMessageModel.strongnessLevel) });


            defenderTransactionModed.firstChatMessageModel.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.AccountOldness);
            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.firstChatMessageModel.suggessions);
            this.webBrowser1.Document.GetElementById("sug_AO").InnerHtml = content;
        }
        private void SetContatList(string value)
        {
            defenderTransactionModed.contactList = new TotalNumberOfChatsModel();
            
            defenderTransactionModed.contactList.totalChats = Convert.ToInt32(value);
            defenderTransactionModed.contactList.percentage = AlgorithmCalculator.CalculatePercentage_For_ContactList(defenderTransactionModed.contactList.totalChats);
            defenderTransactionModed.contactList.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.contactList.percentage);
            webBrowser1.Document.InvokeScript("setContactList", new string[] { defenderTransactionModed.contactList.totalChats.ToString(), defenderTransactionModed.contactList.percentage.ToString(), defenderTransactionModed.contactList.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.contactList.strongnessLevel) });


            defenderTransactionModed.contactList.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.ContactListCount);
            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.contactList.suggessions);
            this.webBrowser1.Document.GetElementById("sug_CLC").InnerHtml = content;
        }

        private void SetSavedChats(string value)
        {
            defenderTransactionModed.savedchats = new TotalNumberOfChatsModel();
            defenderTransactionModed.savedchats.totalChats = Convert.ToInt32(value);
            defenderTransactionModed.savedchats.percentage = AlgorithmCalculator.CalculatePercentage_For_UnSavedChats(defenderTransactionModed.savedchats.totalChats);
            defenderTransactionModed.savedchats.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.savedchats.percentage);
            webBrowser1.Document.InvokeScript("setSavedChats", new string[] { defenderTransactionModed.savedchats.totalChats.ToString(), defenderTransactionModed.savedchats.percentage.ToString(), defenderTransactionModed.savedchats.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.savedchats.strongnessLevel) });

            defenderTransactionModed.savedchats.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.TotalChatsWithContacts);
            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.savedchats.suggessions);
            this.webBrowser1.Document.GetElementById("sug_TCWC").InnerHtml = content;
        }
        private void SetUnSavedChats(string value)
        {
            defenderTransactionModed.unsavedchats = new TotalNumberOfChatsModel();
            defenderTransactionModed.unsavedchats.totalChats = Convert.ToInt32(value);
            defenderTransactionModed.unsavedchats.percentage = AlgorithmCalculator.CalculatePercentage_For_UnSavedChats(defenderTransactionModed.unsavedchats.totalChats);
            defenderTransactionModed.unsavedchats.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.unsavedchats.percentage);
            webBrowser1.Document.InvokeScript("setUnSavedChats", new string[] { defenderTransactionModed.unsavedchats.totalChats.ToString(), defenderTransactionModed.unsavedchats.percentage.ToString(), defenderTransactionModed.unsavedchats.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.unsavedchats.strongnessLevel) });


            defenderTransactionModed.unsavedchats.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.UnSavedChats);
            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.unsavedchats.suggessions);
            this.webBrowser1.Document.GetElementById("sug_TNC").InnerHtml = content;
        }

        private void SetTotalNOtInteresteds()
        {
            defenderTransactionModed.noInterestedModel.percentage = AlgorithmCalculator.CalculateTotalNonInterestedPercentage(defenderTransactionModed.noInterestedModel.NumberOfotInteestedChats.Count);

            try
            {
                defenderTransactionModed.noInterestedModel.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.noInterestedModel.percentage);
            }
            catch (Exception ex)
            {

            }

            webBrowser1.Document.InvokeScript("setTotalNumberOfNotInteresteds", new string[] { defenderTransactionModed.noInterestedModel.NumberOfotInteestedChats.Count().ToString(), defenderTransactionModed.noInterestedModel.percentage.ToString(), defenderTransactionModed.noInterestedModel.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.noInterestedModel.strongnessLevel) });

            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.noInterestedModel.suggessions);
            this.webBrowser1.Document.GetElementById("sug_NOC").InnerHtml = content;
        }

        private void SetTotalNumberOfGroups(string value)
        {
            defenderTransactionModed.totalGroups = new TotalNumberOfChatsModel();
            defenderTransactionModed.totalGroups.totalChats = Convert.ToInt32(value);
            defenderTransactionModed.totalGroups.percentage = AlgorithmCalculator.CalculateTotalNumberOfGrpupPercentage(defenderTransactionModed.totalGroups.totalChats);
            defenderTransactionModed.totalGroups.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.totalGroups.percentage);
            webBrowser1.Document.InvokeScript("setTotalNumberOfGroups", new string[] { defenderTransactionModed.totalGroups.totalChats.ToString(), defenderTransactionModed.totalGroups.percentage.ToString(), defenderTransactionModed.totalGroups.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.totalGroups.strongnessLevel) });


            defenderTransactionModed.totalGroups.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.NumberOfGroups);
            string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.totalGroups.suggessions);
            this.webBrowser1.Document.GetElementById("sug_TNG").InnerHtml = content;
        }

      

        private void SetTotalNumberOfCHats(string value)
        {
            try
            {
                defenderTransactionModed.totalNumberOfChatsModel = new TotalNumberOfChatsModel();
                defenderTransactionModed.totalNumberOfChatsModel.suggessions = AlgorithmCalculator.getSuggessions(ModulesEnum.TotalNumberOfChats);
                defenderTransactionModed.totalNumberOfChatsModel.totalChats = Convert.ToInt32(value);
                defenderTransactionModed.totalNumberOfChatsModel.percentage = AlgorithmCalculator.CalculateTotalNumberOfchatPercentage(defenderTransactionModed.totalNumberOfChatsModel.totalChats);
                defenderTransactionModed.totalNumberOfChatsModel.strongnessLevel = AlgorithmCalculator.LevelCalculator(defenderTransactionModed.totalNumberOfChatsModel.percentage);
                webBrowser1.Document.InvokeScript("setTotalNumberOfChats", new string[] { defenderTransactionModed.totalNumberOfChatsModel.totalChats.ToString(), defenderTransactionModed.totalNumberOfChatsModel.percentage.ToString(), defenderTransactionModed.totalNumberOfChatsModel.strongnessLevel.ToString(), Utils.returnLevelString(defenderTransactionModed.totalNumberOfChatsModel.strongnessLevel) });

                string content = AlgorithmCalculator.generateSuggessionHTML(defenderTransactionModed.totalNumberOfChatsModel.suggessions);
                this.webBrowser1.Document.GetElementById("sug_TNOC").InnerHtml = content;
            }
            catch (Exception ex)
            {
                sendException("pgbOneStrongness", ex);
            }
        }

        private void sendException(string elementId, Exception ex)
        {
            //invokeScripe("handleException(`"+ elementId + "`,`"+ ex.Message + "`)");
            webBrowser1.Document.InvokeScript("handleException", new string[] { elementId, "Error" });
        }

        private async Task<string> initJA()
        {
            if (!await Utils.waBrowser.isWPPIInited())
            {
                string _result = await Utils.waBrowser.InjectWapi();
                return _result;
            }
            return "";
        }
        private async Task<string> getTotalNumberOfCats()
        {
            string totalchats = await WPPHelper.getTotalChats(Utils.waBrowser.webView21);
            return totalchats;
        }

        private async Task<string> getTotalNumberOfGroups()
        {
            string totalchats = await WPPHelper.getTotalGroups(Utils.waBrowser.webView21);
            return totalchats;
        }

        private void materialButton35_Click(object sender, EventArgs e)
        {
            initWA();
        }

        private void btnInitWA_Click(object sender, EventArgs e)
        {
            initWA();
            checkQRScanDone();
        }

        private void initWA()
        {

            bool bFormNameOpen = false;

            FormCollection fc = Application.OpenForms;

            foreach (Form frm in fc)
            {
                if (frm.Name == "WebWaView")
                {
                    bFormNameOpen = true;
                }
            }

            ChangeInitStatus(InitStatusEnum.Initialising);

            if (Utils.waBrowser == null)
            {
                Utils.waBrowser = new WaBrowser(this);
            }
            Utils.waBrowser.Show();

        }

        public void WebViewClosed()
        {
            ChangeInitStatus(InitStatusEnum.Stopped);
            ChangeCampStatus(CampaignStatusEnum.Stopped);
        }

        private void checkQRScanDone()
        {
            timerInitChecker = new System.Windows.Forms.Timer();
            timerInitChecker.Interval = 1000;
            timerInitChecker.Tick += timerInitChecker_Tick;
            timerInitChecker.Start();
        }

        public async void timerInitChecker_Tick(object sender, EventArgs e)
        {
            try
            {
                try
                {
                    string isInitiated = await Utils.waBrowser.isWaInited();
                    if (isInitiated == "true")
                    {
                        ChangeInitStatus(InitStatusEnum.Initialised);
                        timerInitChecker.Stop();
                        //initBackgroundWorker();
                        Activate();

                    }
                }
                catch (Exception ex)
                {
                    string ss = "";
                }
            }
            catch (Exception ex)
            {
                //logger.WriteLog(ex.Message);
                ChangeInitStatus(InitStatusEnum.Unable);
                timerInitChecker.Stop();
            }
        }

        private void materialCard1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void materialButton2_Click(object sender, EventArgs e)
        {
            GeneralSettings generalSettings = new GeneralSettings();
            generalSettings.ShowDialog();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            generalSettingsModel.selectedLanguage = comboBox1.Text;

            String GetGeneralSettingsFilePath = Config.GetGeneralSettingsFilePath();
            if (!File.Exists(GetGeneralSettingsFilePath))
            {
                File.Create(GetGeneralSettingsFilePath).Close();
            }

            string Json = JsonConvert.SerializeObject(generalSettingsModel, Formatting.Indented);
            File.WriteAllText(GetGeneralSettingsFilePath, Json);

            MaterialSnackBar SnackBarMessage = new MaterialSnackBar(Strings.LanguageIsSet, Strings.OK, true);
            SnackBarMessage.Show(this);
        }

        
    }
}
